diff --git a/lib/libcheri_caprevoke/libcheri_caprevoke.c b/lib/libcheri_caprevoke/libcheri_caprevoke.c
new file mode 100644
index 000000000000..775e31be07a0
--- /dev/null
+++ b/lib/libcheri_caprevoke/libcheri_caprevoke.c
@@ -0,0 +1,486 @@
+/*
+ * Revocation bitmap manipulation operations.
+ */
+
+// XXX This can't possibly be right.  Should vmparam.h be checking for
+// something else?
+#ifndef CPU_CHERI
+#define CPU_CHERI
+#endif
+
+#include <assert.h>
+#include <inttypes.h>
+#include <stdbool.h>
+#include <stdatomic.h>
+#include <stddef.h>
+#include <stdint.h>
+
+#include <cheri/cheric.h>
+
+#include <sys/param.h>
+#include <sys/caprevoke.h>
+#include <machine/cherireg.h>
+#include <machine/pte.h>
+#include <machine/vmparam.h>
+#include "caprevoke.h"
+
+static ptrdiff_t caprev_shadow_nomap_first_word_offset(vaddr_t base);
+static ptrdiff_t caprev_shadow_nomap_last_word_offset(vaddr_t base, size_t len);
+static uint64_t  caprev_shadow_nomap_first_word_mask(vaddr_t base, size_t len);
+static uint64_t  caprev_shadow_nomap_last_word_mask(vaddr_t base, size_t len);
+
+  /*
+   * Given a capability to an object, derive the offset relative to the base of
+   * the fine-grained bitmap where the first word would be located.
+   */
+
+static ptrdiff_t
+caprev_shadow_nomap_first_word_offset(vaddr_t base)
+{
+  return (ptrdiff_t)(base / VM_CAPREVOKE_GSZ_MEM_NOMAP
+                          / 8
+                          / sizeof(uint64_t)) * sizeof(uint64_t);
+}
+
+static ptrdiff_t
+caprev_shadow_nomap_last_word_offset(vaddr_t base, size_t len)
+{
+  if (len == 0)
+    return caprev_shadow_nomap_first_word_offset(base);
+
+  return (ptrdiff_t)((base + len - 1)
+                          / VM_CAPREVOKE_GSZ_MEM_NOMAP
+                          / 8
+                          / sizeof(uint64_t)) * sizeof(uint64_t);
+}
+
+  /*
+   * Derive the mask to be or'd in to the first word to mark the object's
+   * bottom granules as revoked.
+   */
+
+static uint64_t
+caprev_shadow_nomap_first_word_mask(vaddr_t base, size_t len)
+{
+  uint64_t res;
+
+  /* What's the least significant bit's position within the word? */
+  int lsb = (base / VM_CAPREVOKE_GSZ_MEM_NOMAP) % (8 * sizeof(uint64_t));
+
+  if (caprev_shadow_nomap_first_word_offset(base) ==
+      caprev_shadow_nomap_last_word_offset(base, len)) {
+    /* The object occupies only some bits in the first word */
+
+    int setwidth = len / VM_CAPREVOKE_GSZ_MEM_NOMAP;
+
+    if (lsb + setwidth == 64) {
+      /* Object fills this word completely, but does not spill to the next */
+
+      res = ~(((uint64_t)1 << lsb) - 1);
+    } else {
+      res = (   ~(((uint64_t)1 << (lsb + setwidth)) - 1)
+             ^ (~(((uint64_t)1 << lsb             ) - 1)));
+    }
+  } else {
+    /* The object runs off the end of this word. */
+
+    res = ~(((uint64_t)1 << lsb) - 1);
+  }
+
+#if __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
+  return __builtin_bswap64(res);
+#elif __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
+  return res;
+#else
+# error
+#endif
+}
+
+static uint64_t
+caprev_shadow_nomap_last_word_mask(vaddr_t base, size_t len)
+{
+  uint64_t res;
+
+  if (caprev_shadow_nomap_first_word_offset(base) ==
+      caprev_shadow_nomap_last_word_offset(base, len)) {
+
+    /*
+     * There are no more bits to set that haven't been taken care of by the the
+     * first word, so just return 0.
+     */
+
+    return 0;
+  }
+
+  int msb = ((base + len - 1) / VM_CAPREVOKE_GSZ_MEM_NOMAP) % (8 * sizeof(uint64_t));
+
+  if (msb == 63) {
+    /* This object runs to the end of its last word */
+
+    return ~(uint64_t)0;
+  }
+
+  res = ((uint64_t)1 << (msb+1)) - 1;
+
+#if __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
+  return __builtin_bswap64(res);
+#elif __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
+  return res;
+#else
+# error
+#endif
+}
+
+  /*
+   * Exposed for testing, but hopefully inlined into the actual update
+   * functions below.
+   *
+   * XXX Slightly less polluting of the external namespace than having all four
+   * functions available, maybe?
+   */
+
+void
+caprev_shadow_nomap_offsets(vaddr_t ob, size_t len, ptrdiff_t *fwo, ptrdiff_t *lwo)
+{
+  *fwo = caprev_shadow_nomap_first_word_offset(ob);
+  *lwo = caprev_shadow_nomap_last_word_offset(ob, len);
+}
+
+void
+caprev_shadow_nomap_masks(vaddr_t ob, size_t len, uint64_t *fwm, uint64_t *lwm)
+{
+  *fwm = caprev_shadow_nomap_first_word_mask(ob, len);
+  *lwm = caprev_shadow_nomap_last_word_mask(ob, len);
+}
+
+  /*
+   * A helper function for some things both setting and clearing shadow masks
+   * need up front.
+   */
+
+static inline void
+caprev_shadow_nomap_common_pfx(uint64_t * __capability sb,
+             vaddr_t ob, size_t len, ptrdiff_t *fwo, ptrdiff_t *lwo,
+             uint64_t * __capability *fw
+            )
+{
+  caprev_shadow_nomap_offsets(ob, len, fwo, lwo);
+
+  *fw = cheri_setaddress(sb, VM_CAPREVOKE_BM_MEM_NOMAP + *fwo);
+}
+
+  /*
+   * Mark an object for revocation using the indicated capability to the
+   * correct fragment of the shadow bitmap.
+   *
+   * The region of memory whose corresponding shadow space will be set is given
+   * by a base vaddr ob and a length len. The "user" object capability is
+   * expected to govern a subset of this region and, importantly, must be
+   * subject to revocation; it is used to guard against double-frees. The two
+   * are provided separately because the bounds of the "user" capability may
+   * have been shrunk so that they do not cover the entire underlying allocation.
+   *
+   * The masks here are additive: they're going to be OR'd with the shadow.
+   *
+   * Returns 0 on success or 1 if the calling free() should skip this
+   * capability, as it has either become de-tagged or is at least partially
+   * already marked in the bitmap (as might happen, for example, with a
+   * racing second call to free on the same pointer).
+   */
+
+int
+caprev_shadow_nomap_set_len(uint64_t * __capability sb,
+                            vaddr_t ob,
+                            size_t len,
+                            void * __capability user_obj)
+{
+  ptrdiff_t fwo, lwo;
+  uint64_t * __capability fw;
+
+  caprev_shadow_nomap_common_pfx(sb, ob, len, &fwo, &lwo, &fw);
+
+  uint64_t fwm = caprev_shadow_nomap_first_word_mask(ob, len);
+
+  uint64_t asmres = 0;
+
+  /*
+   * The first word is tricky to handle, since we use it to gate frees,
+   * ensuring that double-frees are idempotent.  There are three reasons we
+   * might bail out:
+   *
+   *   - another thread has quarantined this object (bits already set)
+   *
+   *   - this object is detagged
+   *
+   *   - this object has been revoked while we held a pointer to it in
+   *   free() (and so its permissions have been stripped; see cheri_revoke)
+   *
+   * We have to check the permissions inside the ll/sc we use to update the
+   * shadow bitmask so that we interlock against the stop-the-world (and
+   * maybe read-side) phases of revocation.
+   *
+   * It's possible the SC fails for neither of the above reasons, of course,
+   * not the least of which is that a concurrent thread might be mutating
+   * the shadow.  In that case, just go around again.
+   *
+   * We're going to do this dance with some inline assembler (sigh), because
+   * it's a little much to expect C to understand!
+   */
+#ifdef __mips__
+
+  // t0: the local, manipulated copy of the shadow
+  // t1: temp value
+
+  // XXX Why is someone inserting nops in my carefully-written assembler? :(
+
+  __asm__ __volatile__ (
+      "1:\n\t"
+      "clld $t0, %[fw]\n\t"             // Load linked the first word
+
+      "and $t1, $t0, %[fwm]\n\t"        // Jump out if shadow set
+      "bnez $t1, 2f\n\t"
+      "nop\n\t"                         // [delay]
+
+      "cbtu %[obj], 2f\n\t"             // Jump out if object detagged
+	// no delay slot OK
+
+      "cgetperm $t1, %[obj]\n\t"        // Jump out if zero perms
+      "beqz $t1, 2f\n\t"
+      "nop\n\t"                         // [delay]
+
+      "or $t0, $t0, %[fwm]\n\t"         // bitwise or in the mask [delay]
+
+      "cscd %[asmres], $t0, %[fw]\n\t"  // SC the updated mask
+      "bnez %[asmres], 2f\n\t"          // Jump out on success
+      "nop\n\t"                         // [delay]
+
+      "j 1b\n\t"                        // Go again if SC failed
+      "nop\n\t"
+
+      "2:\n\t"
+    : // output operands
+      [asmres] "+r" (asmres)
+    : // input operands
+      [obj]    "C"  (user_obj),
+      [fw]     "C"  (fw),
+      [fwm]    "r"  (fwm)
+     : // clobbers
+       "t0", "t1", "memory"
+  );
+#else
+#  error Unable to mark bitmaps on this architecture
+#endif
+
+  /*
+   * In the "Jump out" cases above, %[asmres] will hold the value 0, either
+   * from initialization or because a cscd instruction was unsuccessful on a
+   * prior iteration.  Only if we don't jump out and successfully exit the loop
+   * will asmres be 1.
+   */
+  if (asmres == 0) {
+    return 1;
+  }
+
+  if (lwo != fwo) {
+
+    /*
+     * If this object straddles a word boundary, the first and last word offets
+     * will not be equal; the last word might also need special handling.
+     */
+
+    uint64_t * __capability lw = cheri_setaddress(sb,
+                                    VM_CAPREVOKE_BM_MEM_NOMAP + lwo);
+    uint64_t lwm = caprev_shadow_nomap_last_word_mask(ob, len);
+
+    /*
+     * We might overlap a concurrent object's attempt to mutate bits in the
+     * last word, so do the OR atomically unless we're setting the whole word,
+     * in which case, the write cannot possibly race.
+     */
+
+    if (lwm != ~(uint64_t)0) {
+      atomic_fetch_or_explicit((_Atomic(uint64_t) * __capability)lw, lwm,
+                               memory_order_relaxed);
+    } else {
+      *lw = ~(uint64_t)0;
+    }
+
+    /*
+     * Any words between the first and last we can just set all at once;
+     * there's nothing else to see here.
+     */
+
+    ptrdiff_t wo = fwo + sizeof(uint64_t);
+    uint64_t * __capability sbo = fw + 1;
+    for (; wo < lwo; wo += sizeof(uint64_t), sbo++) {
+      *sbo = ~(uint64_t)0;
+    }
+  }
+
+  /*
+   * There is no need to store-barrier or any such here; we can enforce store
+   * order before grabbing the epoch clock for this *chunk* of the quarantine.
+   * By ensuring that we make all cores aware of our bits before looking at the
+   * clock, we guarantee that the revocation epoch(s) upon which we are waiting
+   * will be done with at least our stores visible.
+   */
+
+  return 0;
+}
+
+  /*
+   * Mark an object for revocation using the indicated capability to the
+   * correct fragment of the shadow bitmap.
+   *
+   * The "privileged" object capability is expected to point to the full,
+   * actual bounds of the allocation and may (or may not) be subject to
+   * revocation; this capability determines which bits of the bitmap are in
+   * scope for changes.  The "user" object capability is expected to be a
+   * subset of the privileged object capability and, importantly, must be
+   * subject to revocation; this capability is used to guard against
+   * double-frees.  The two are provided separately to remove from the
+   * allocator the need to construct the priveleged capability while
+   * respecting (concurrently mutable!) taggedness of the user capability.
+   *
+   * The masks here are additive: they're going to be OR'd with the shadow.
+   *
+   * Returns 0 on success or 1 if the calling free() should skip this
+   * capability, as it has either become de-tagged or is at least partially
+   * already marked in the bitmap (as might happen, for example, with a
+   * racing second call to free on the same pointer).
+   */
+
+int
+caprev_shadow_nomap_set(uint64_t * __capability sb,
+                        void * __capability priv_obj,
+                        void * __capability user_obj)
+{
+  return caprev_shadow_nomap_set_len(sb, (__cheri_addr vaddr_t)priv_obj, cheri_getlen(priv_obj), user_obj);
+}
+
+  /*
+   * Clear a region from the shadow bitmap.
+   *
+   * The masks here are subtractive: they're going to be AND'd with the shadow.
+   */
+
+void
+caprev_shadow_nomap_clear_len(uint64_t * __capability sb, vaddr_t ob, size_t len)
+{
+  ptrdiff_t fwo, lwo;
+  uint64_t * __capability fw;
+
+  caprev_shadow_nomap_common_pfx(sb, ob, len, &fwo, &lwo, &fw);
+
+  uint64_t fwm = ~caprev_shadow_nomap_first_word_mask(ob, len);
+
+  /*
+   * The first word must be handled atomically, so that it interlocks
+   * with the atomic manipulation in caprev_shadow_nomap_set.
+   */
+  atomic_fetch_and_explicit((_Atomic(uint64_t) * __capability)fw, fwm,
+                            memory_order_relaxed);
+
+  if (lwo != fwo) {
+
+    uint64_t * __capability lw = cheri_setaddress(sb,
+                                    VM_CAPREVOKE_BM_MEM_NOMAP + lwo);
+    uint64_t lwm = ~caprev_shadow_nomap_last_word_mask(ob, len);
+
+    /*
+     * The last word may also need to be handled atomically.
+     */
+
+    if (lwm != 0) {
+      atomic_fetch_and_explicit((_Atomic(uint64_t) * __capability)lw, lwm,
+                                memory_order_relaxed);
+    } else {
+      *lw = 0;
+    }
+
+    /*
+     * Any words between the first and last we can just clear all at once.
+     */
+
+    ptrdiff_t wo = fwo + sizeof(uint64_t);
+    uint64_t * __capability sbo = fw + 1;
+    for (; wo < lwo; wo += sizeof(uint64_t), sbo++) {
+      *sbo = (uint64_t)0;
+    }
+  }
+
+  /*
+   * There is no need to store-barrier or any such here either.  It suffices to
+   * store-barrier at the end of whatever set of objects is being cleared from
+   * the shadow, before those objects may be released to the application.
+   */
+}
+
+  /*
+   * Clear an object from the shadow bitmap.
+   *
+   * The masks here are subtractive: they're going to be AND'd with the shadow.
+   */
+
+void
+caprev_shadow_nomap_clear(uint64_t * __capability sb, void * __capability obj)
+{
+  return caprev_shadow_nomap_clear_len(sb, (__cheri_addr vaddr_t)obj, cheri_getlen(obj));
+}
+
+/*
+ * The "raw" interfaces presume that all interlocking has already been
+ * managed by the caller and so contain no atomics or such!
+ */
+
+void
+caprev_shadow_nomap_set_raw(uint64_t * __capability sb,
+                            vaddr_t heap_start, vaddr_t heap_end)
+{
+  ptrdiff_t fwo, lwo;
+  uint64_t * __capability fw;
+  size_t len = heap_end - heap_start;
+
+  caprev_shadow_nomap_offsets(heap_start, len, &fwo, &lwo);
+
+  fw = cheri_setaddress(sb, VM_CAPREVOKE_BM_MEM_NOMAP + fwo);
+  *fw |= caprev_shadow_nomap_first_word_mask(heap_start, len);
+
+  if (lwo != fwo) {
+    uint64_t * __capability w = fw + 1;
+    ptrdiff_t wo = fwo + sizeof(uint64_t);
+    w = fw + 1;
+    for (; wo < lwo; wo += sizeof(uint64_t), w++) {
+		*w = ~(uint64_t)0;
+	}
+
+    w = cheri_setaddress(sb, VM_CAPREVOKE_BM_MEM_NOMAP + lwo);
+    *w |= caprev_shadow_nomap_last_word_mask(heap_start, len);
+  }
+}
+
+void
+caprev_shadow_nomap_clear_raw(uint64_t * __capability sb,
+                              vaddr_t heap_start, vaddr_t heap_end)
+{
+  ptrdiff_t fwo, lwo;
+  uint64_t * __capability fw;
+  size_t len = heap_end - heap_start;
+
+  caprev_shadow_nomap_offsets(heap_start, len, &fwo, &lwo);
+
+  fw = cheri_setaddress(sb, VM_CAPREVOKE_BM_MEM_NOMAP + fwo);
+  *fw &= ~caprev_shadow_nomap_first_word_mask(heap_start, len);
+
+  if (lwo != fwo) {
+    uint64_t * __capability w = fw + 1;
+    ptrdiff_t wo = fwo + sizeof(uint64_t);
+    w = fw + 1;
+    for (; wo < lwo; wo += sizeof(uint64_t), w++) {
+		*w = 0;
+	}
+
+    w = cheri_setaddress(sb, VM_CAPREVOKE_BM_MEM_NOMAP + lwo);
+    *w &= ~caprev_shadow_nomap_last_word_mask(heap_start, len);
+  }
+}
diff --git a/lib/libmalloc_simple/Makefile b/lib/libmalloc_simple/Makefile
index 7a19330aeb7e..4651c6f6fb9c 100644
--- a/lib/libmalloc_simple/Makefile
+++ b/lib/libmalloc_simple/Makefile
@@ -1,8 +1,14 @@
 # $FreeBSD$
 
+.include <src.opts.mk>
+
 LIB=	malloc_simple
 SHLIB_MAJOR=	1
 
 SRCS=	heap.c malloc.c
 
+.if ${MACHINE_ARCH:Mmips*c*} && ${MK_CHERI_CAPREVOKE}
+CFLAGS+=	-DCAPREVOKE
+.endif
+
 .include <bsd.lib.mk>
diff --git a/lib/libmalloc_simple/heap.c b/lib/libmalloc_simple/heap.c
index 5910dd57351e..bc2c94505486 100644
--- a/lib/libmalloc_simple/heap.c
+++ b/lib/libmalloc_simple/heap.c
@@ -46,8 +46,17 @@ static char *rcsid = "$FreeBSD$";
 
 #include <sys/param.h>
 #include <sys/types.h>
+#ifdef CAPREVOKE
+#include <sys/caprevoke.h>
+#endif
 #include <sys/mman.h>
+#ifdef CAPREVOKE
+#include <sys/stdatomic.h>
+#endif
 
+#ifdef CAPREVOKE
+#include <cheri/caprevoke.h>
+#endif
 #include <cheri/cheri.h>
 #include <cheri/cheric.h>
 
@@ -68,19 +77,36 @@ static char *rcsid = "$FreeBSD$";
 #define	error_printf(...)	fprintf(stderr, __VA_ARGS__)
 #endif
 
+struct pagepool_header {
+	size_t			ph_size;
+#ifdef __CHERI_PURE_CAPABILITY__
+	size_t			ph_pad1;
+	/* XXXBD: more padding on 256-bit... */
+#endif
+	struct pagepool_header	*ph_next;
+#ifdef CAPREVOKE
+	void			*ph_shadow;
+#else
+	void			*ph_pad2;
+#endif
+};
+
 #define	NPOOLPAGES	(32*1024/_pagesz)
 
 caddr_t		pagepool_start, pagepool_end;
+static struct pagepool_header	*curpp;
 
-static size_t n_pagepools, max_pagepools;
-static char **pagepool_list;
 static size_t _pagesz;
 
+#ifdef CAPREVOKE
+static volatile const struct caprevoke_info *cri;
+#endif
+
 int
 __morepages(int n)
 {
 	size_t	size;
-	char **new_pagepool_list;
+	struct pagepool_header *newpp;
 
 	n += NPOOLPAGES;	/* round up allocation. */
 	size = n * _pagesz;
@@ -88,30 +114,6 @@ __morepages(int n)
 	size = CHERI_REPRESENTABLE_LENGTH(size);
 #endif
 
-	if (n_pagepools >= max_pagepools) {
-		if (max_pagepools == 0)
-			max_pagepools = _pagesz / (sizeof(char *) * 2);
-
-		max_pagepools *= 2;
-		if ((new_pagepool_list = mmap(0,
-		    max_pagepools * sizeof(char *), PROT_READ|PROT_WRITE,
-		    MAP_ANON, -1, 0)) == MAP_FAILED) {
-			error_printf("%s: Can not map pagepool_list\n", __func__);
-			return (0);
-		}
-		memcpy(new_pagepool_list, pagepool_list,
-		    sizeof(char *) * n_pagepools);
-		if (pagepool_list != NULL) {
-			if (munmap(pagepool_list,
-			    max_pagepools * sizeof(char *) / 2) != 0) {
-				error_printf("%s: failed to unmap pagepool_list\n",
-				    __func__);
-				/* XXX: leak the region */
-			}
-		}
-		pagepool_list = new_pagepool_list;
-	}
-
 	if (pagepool_end - pagepool_start > (ssize_t)_pagesz) {
 		caddr_t extra_start = __builtin_align_up(pagepool_start,
 		    _pagesz);
@@ -138,13 +140,16 @@ __morepages(int n)
 #endif
 	}
 
-	if ((pagepool_start = mmap(0, size, PROT_READ|PROT_WRITE,
-	    MAP_ANON, -1, 0)) == MAP_FAILED) {
+	if ((newpp = mmap(0, size, PROT_READ|PROT_WRITE, MAP_ANON, -1,
+	    0)) == MAP_FAILED) {
 		error_printf("%s: mmap of pagepool failed\n", __func__);
 		return (0);
 	}
-	pagepool_end = pagepool_start + size;
-	pagepool_list[n_pagepools++] = pagepool_start;
+	newpp->ph_next = curpp;
+	newpp->ph_size = size;
+	curpp = newpp;
+	pagepool_start = (char *)(newpp + 1);
+	pagepool_end = pagepool_start + (size - sizeof(*newpp));
 
 	return (size / _pagesz);
 }
@@ -159,16 +164,66 @@ __init_heap(size_t pagesz)
 void *
 __rederive_pointer(void *ptr)
 {
-	size_t i;
+	struct pagepool_header *pp;
 	vm_offset_t addr;
 
 	addr = cheri_getaddress(ptr);
-	for (i = 0; i < n_pagepools; i++) {
-		char *pool = pagepool_list[i];
-
+	pp = curpp;
+	while (pp != NULL) {
+		char *pool = (char *)pp;
 		if (cheri_is_address_inbounds(pool, addr))
 			return (cheri_setaddress(pool, addr));
+		pp = pp->ph_next;
 	}
 
 	return (NULL);
 }
+
+
+#ifdef CAPREVOKE
+void
+__paint_shadow(void *mem, size_t size)
+{
+	struct pagepool_header *pp;
+
+	pp = cheri_setoffset(pp, 0);
+	/*
+	 * Defer initializing ph_shadow since odds are good we'll never
+	 * need it.
+	 */
+	if (pp->ph_shadow == NULL)
+		if (caprevoke_shadow(CAPREVOKE_SHADOW_NOVMMAP, pp,
+		    &pp->ph_shadow) != 0)
+			abort();
+	caprev_shadow_nomap_set_raw(pp->ph_shadow, (vaddr_t)mem, size);
+}
+
+void
+__clear_shadow(void *mem, size_t size)
+{
+	struct pagepool_header *pp;
+
+	pp = cheri_setoffset(pp, 0);
+	caprev_shadow_nomap_clear_raw(pp->ph_shadow, (vaddr_t)mem, size);
+}
+
+void
+__do_revoke(void)
+{
+	int error;
+
+	if (cri == NULL) {
+		error = caprevoke_shadow(CAPREVOKE_SHADOW_INFO_STRUCT, NULL,
+		    __DECONST(void **, &cri));
+		assert(error == 0);
+	}
+
+	caprevoke_epoch start_epoch = cri->epoch_enqueue;
+	while (!caprevoke_epoch_clears(cri->epoch_dequeue, start_epoch)) {
+		struct caprevoke_stats crst;
+		error = caprevoke(CAPREVOKE_LAST_PASS, start_epoch, &crst);
+		assert(error == 0);
+	}
+}
+
+#endif /* CAPREVOKE */
diff --git a/lib/libmalloc_simple/malloc.c b/lib/libmalloc_simple/malloc.c
index a48a9f0cfe0e..d04f098e59e4 100644
--- a/lib/libmalloc_simple/malloc.c
+++ b/lib/libmalloc_simple/malloc.c
@@ -45,8 +45,15 @@ static char *rcsid = "$FreeBSD$";
  */
 
 #include <sys/param.h>
+#ifdef CAPREVOKE
+#include <sys/caprevoke.h>
+#include <sys/stdatomic.h>
+#endif
 #include <sys/types.h>
 
+#ifdef CAPREVOKE
+#include <cheri/caprevoke.h>
+#endif
 #include <cheri/cheri.h>
 #include <cheri/cheric.h>
 
@@ -98,10 +105,28 @@ union	overhead {
  * (FIRST_BUCKET_SIZE << i).  The overhead information precedes the
  * data area returned to the user.
  */
-#define	FIRST_BUCKET_SIZE	32
+#define	FIRST_BUCKET_SHIFT	5
+#define	FIRST_BUCKET_SIZE	(1 << FIRST_BUCKET_SHIFT)
 #define	NBUCKETS 30
 static	union overhead *nextf[NBUCKETS];
 
+#ifdef CAPREVOKE
+/*
+ * In the CAPREVOKE case, we encode the bucket in the next pointer's low
+ * bit in the quarantine pool.  The static assert ensures that remains
+ * possible.
+ */
+_Static_assert(NBUCKETS < FIRST_BUCKET_SIZE,
+    "Not enough alignment to encode bucket in pointer bits");
+#define	MAX_QUARANTINE	(1024 * 1024)
+#define	MAX_PAINTED	(4 * MAX_QUARANTINE)
+static	union overhead *quarantine_bufs[NBUCKETS];
+static	union overhead *painted_bufs[NBUCKETS];
+static	size_t quarantine_size, painted_size;
+static	volatile const struct caprevoke_info *cri;
+static	caprevoke_epoch painted_epoch;
+#endif
+
 static	size_t pagesz;			/* page size */
 
 
@@ -131,6 +156,92 @@ bound_ptr(void *mem, size_t nbytes)
 	return (ptr);
 }
 
+#ifdef CAPREVOKE
+static void
+free_painted(void)
+{
+	int bucket;
+	union overhead *op, *next_op;;
+
+	for (bucket = 0; bucket < NBUCKETS; bucket++)
+		for (op = painted_bufs[bucket]; op != NULL; op = op->ov_next)
+			__clear_shadow(op, FIRST_BUCKET_SIZE << bucket);
+
+	/* XXX: how do we know that no thread is revoking? */
+	atomic_thread_fence(memory_order_acq_rel);
+
+	for (bucket = 0; bucket < NBUCKETS; bucket++) {
+		op = painted_bufs[bucket];
+		while (op != NULL) {
+			next_op = op->ov_next;
+			op->ov_next = nextf[bucket];
+			nextf[bucket] = op;
+			op = next_op;
+		}
+	}
+	painted_size = 0;
+}
+
+static void
+try_revoke(int target_bucket)
+{
+	int bucket, error;
+	union overhead *op, *next_op;
+
+	/* See if prior painting has resulted in revoked pointers. */
+	/*
+	 * NB: despite the NULL check below, cri is always non-NULL if
+	 * used here.  We defer initilization as long as possible to
+	 * avoid the extra syscall in the common case.
+	 */
+	if (painted_size > 0 &&
+	    caprevoke_epoch_clears(cri->epoch_dequeue, painted_epoch))
+		free_painted();
+
+	if (quarantine_size < MAX_QUARANTINE && painted_size < MAX_PAINTED)
+		return;
+
+	if (cri == NULL) {
+		error = caprevoke_shadow(CAPREVOKE_SHADOW_INFO_STRUCT, NULL,
+		    __DECONST(void **, &cri));
+		assert(error == 0);
+	}
+
+	/* Paint all buffers in quarantine */
+	for (bucket = 0; bucket < NBUCKETS; bucket++) {
+		op = quarantine_bufs[bucket];
+		while (op != NULL) {
+			next_op = op->ov_next;
+			__paint_shadow(op, FIRST_BUCKET_SIZE << bucket);
+			op->ov_next = painted_bufs[bucket];
+			painted_bufs[bucket] = op;
+			op = next_op;
+		}
+	}
+	painted_size += quarantine_size;
+	quarantine_size = 0;
+	atomic_thread_fence(memory_order_acq_rel);
+	painted_epoch = cri->epoch_enqueue;
+
+	/*
+	 * Don't force revocation unless we've exceeded MAX_PAINTED and
+	 * it would return memory we actually want.  Otherwise, just
+	 * hope the base malloc does the job for us.
+	 */
+	if (painted_size < MAX_PAINTED || painted_bufs[target_bucket] == NULL)
+		return;
+
+	while (!caprevoke_epoch_clears(cri->epoch_dequeue, painted_epoch)) {
+		struct caprevoke_stats crst;
+		error = caprevoke(CAPREVOKE_LAST_PASS, painted_epoch, &crst);
+		assert(error == 0);
+	}
+
+	free_painted();
+
+}
+#endif
+
 static void *
 __simple_malloc_unaligned(size_t nbytes)
 {
@@ -166,6 +277,10 @@ __simple_malloc_unaligned(size_t nbytes)
 	 * If nothing in hash bucket right now,
 	 * request more memory from the system.
 	 */
+#ifdef CAPREVOKE
+	if ((op = nextf[bucket]) == NULL)
+		try_revoke(bucket);
+#endif
 	if ((op = nextf[bucket]) == NULL) {
 		morecore(bucket);
 		if ((op = nextf[bucket]) == NULL)
@@ -340,8 +455,14 @@ __simple_free(void *cp)
 		return;
 	bucket = op->ov_index;
 	ASSERT(bucket < NBUCKETS);
+#ifdef CAPREVOKE
+	op->ov_next = quarantine_bufs[bucket];
+	quarantine_bufs[bucket] = op;
+	quarantine_size += FIRST_BUCKET_SIZE << bucket;
+#else
 	op->ov_next = nextf[bucket];	/* also clobbers ov_magic */
 	nextf[bucket] = op;
+#endif
 }
 
 static void *
diff --git a/lib/libmalloc_simple/malloc_heap.h b/lib/libmalloc_simple/malloc_heap.h
index c924aeb9cbe3..3efb856769d9 100644
--- a/lib/libmalloc_simple/malloc_heap.h
+++ b/lib/libmalloc_simple/malloc_heap.h
@@ -39,5 +39,8 @@ extern caddr_t pagepool_end __hidden;
 int	__morepages(int n) __hidden;
 void	__init_heap(size_t pagesz) __hidden;
 void	*__rederive_pointer(void *ptr) __hidden;
+void	__paint_shadow(void *mem, size_t size) __hidden;
+void	__clear_shadow(void *mem, size_t size) __hidden;
+void	__do_revoke(void);
 
 #endif /* __MALLOC_HEAP_H__ */
diff --git a/share/mk/bsd.libnames.mk b/share/mk/bsd.libnames.mk
index 16d95804e70a..9b78743ebc3c 100644
--- a/share/mk/bsd.libnames.mk
+++ b/share/mk/bsd.libnames.mk
@@ -170,6 +170,7 @@ LIBZPOOL?=	${LIBDESTDIR}${LIBDIR_BASE}/libzpool.a
 
 LIBC_NOSYSCALLS?=	${DESTDIR}${LIBDIR_BASE}/libc_nosyscalls.a
 LIBCHERI?=	${DESTDIR}${LIBDIR_BASE}/libcheri.a
+LIBCHERI_CAPREVOKE?=	${DESTDIR}${LIBDIR_BASE}/libcheri_caprevoke.a
 LIBCHERI_SUPPORT?=	${DESTDIR}${LIBDIR_BASE}/libcheri_support.a
 LIBCHERI_SYSCALLS?=	${DESTDIR}${LIBDIR_BASE}/libcheri_syscalls.a
 LIBC_CHERI?=	${DESTDIR}${LIBDIR_BASE}/libc_cheri.a
diff --git a/share/mk/bsd.opts.mk b/share/mk/bsd.opts.mk
index c4c83d7d6bfc..27cd51dd9e04 100644
--- a/share/mk/bsd.opts.mk
+++ b/share/mk/bsd.opts.mk
@@ -79,10 +79,12 @@ __DEFAULT_NO_OPTIONS = \
     STALE_STAGED
 
 __DEFAULT_NO_OPTIONS+= \
+    CHERI_CAPREVOKE \
     CHERI_PURE \
     CHERI128 \
     CHERI256 \
     CHERIBSDBOX \
+    DLMALLOC \
     DEMO_VULNERABILITIES
 
 __DEFAULT_DEPENDENT_OPTIONS = \
diff --git a/share/mk/src.libnames.mk b/share/mk/src.libnames.mk
index 713fae68f4f9..3de9850a16c5 100644
--- a/share/mk/src.libnames.mk
+++ b/share/mk/src.libnames.mk
@@ -90,6 +90,7 @@ _LIBRARIES=	\
 		cam \
 		casper \
 		cheri \
+		cheri_caprevoke \
 		cheri_support \
 		cheri_syscalls \
 		cap_dns \
diff --git a/sys/cheri/cheri_otype.c b/sys/cheri/cheri_otype.c
index 51be5b2f9040..55f75dd9329e 100644
--- a/sys/cheri/cheri_otype.c
+++ b/sys/cheri/cheri_otype.c
@@ -42,6 +42,11 @@ __FBSDID("$FreeBSD$");
 
 #include <machine/cherireg.h>
 
+#ifdef CHERI_CAPREVOKE
+#include <sys/caprevoke.h>
+#include <vm/vm_caprevoke.h>
+#endif
+
 static struct mtx cheri_otype_lock;
 static struct unrhdr *cheri_otypes;
 /* Initialized in _start() */
@@ -82,3 +87,18 @@ cheri_otype_free(otype_t cap)
 	type = cheri_getbase(cap);
 	free_unr(cheri_otypes, type);
 }
+
+#ifdef CHERI_CAPREVOKE
+#ifndef CHERI_CAPREVOKE_CLEARTAGS
+
+/* If this changes, make the comment in sys/sys/caprevoke.h match! */
+void * __capability
+cheri_revoke_sealed(void * __capability c)
+{
+	c = cheri_unseal(c, kernel_sealcap);
+	c = cheri_andperm(c, 0);
+	return c;
+}
+
+#endif
+#endif
